(*
 * Copyright (C) 2003:
 *    Stefano Zacchiroli <zack@cs.unibo.it>
 *    for the HELM Team http://helm.cs.unibo.it/
 *
 *  This file is part of HELM, an Hypertextual, Electronic
 *  Library of Mathematics, developed at the Computer Science
 *  Department, University of Bologna, Italy.
 *
 *  HELM is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  HELM is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with HELM; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 *  MA  02111-1307, USA.
 *
 *  For details, see the HELM World-Wide-Web page,
 *  http://helm.cs.unibo.it/
 *)

open Hbugs_types;;

val broker_url: string

val register_to_broker:
  tutor_id -> string -> hint_type -> string ->
    broker_id
val unregister_from_broker: tutor_id -> unit

val init_tutor: unit -> tutor_id
val load_state:
  Hbugs_types.state ->
    ProofEngineTypes.proof * ProofEngineTypes.goal

module type HbugsTutor =
  sig
    val start: unit -> unit
  end

module type HbugsTutorDescription =
  sig
    val addr: string
    val port: int
    val tactic: ProofEngineTypes.tactic
    val hint: hint
    val hint_type: hint_type
    val description: string
    val environment_file: string
  end

module BuildTutor (Dsc: HbugsTutorDescription) : HbugsTutor

