(*
    ||M||  This file is part of HELM, an Hypertextual, Electronic        
    ||A||  Library of Mathematics, developed at the Computer Science     
    ||T||  Department, University of Bologna, Italy.                     
    ||I||                                                                
    ||T||  HELM is free software; you can redistribute it and/or         
    ||A||  modify it under the terms of the GNU General Public License   
    \   /  version 2 or (at your option) any later version.      
     \ /   This software is distributed as is, NO WARRANTY.     
      V_______________________________________________________________ *)

(* $Id: nCicRefiner.mli 9227 2008-11-21 16:00:06Z tassi $ *)

type db

(* index (\x.c ?? x ??): A -> B
   index_coercion db c A B \arity_left(c ??x??) \position(x,??x??) 
*)
val index_coercion: 
  db -> NCic.term -> NCic.term -> NCic.term -> int -> int -> db

  (* gets the old imperative coercion DB *)
val db : unit -> db

val empty_db : db

val look_for_coercion:
    db ->
    NCic.metasenv -> NCic.substitution -> NCic.context -> 
    (* inferred type, expected type *)
    NCic.term -> NCic.term -> 
      (* enriched metasenv, new term, its type, metavriable to
       * be unified with the old term *)
      (NCic.metasenv * NCic.term * NCic.term * NCic.term) list
